using FooTheory.CodeCamp.DI.Domain;
using FooTheory.CodeCamp.DI.Interfaces.Domain;
using FooTheory.CodeCamp.DI.Interfaces.DTO;
using FooTheory.CodeCamp.DI.Interfaces.Services.Mappers;
using FooTheory.CodeCamp.DI.Services.Mappers;
using NUnit.Framework;
using NUnit.Framework.SyntaxHelpers;

namespace FooTheory.CodeCamp.DI.UnitTests.Services.Mappers
{
    [TestFixture]
    public class CustomerDTOMapperTests
    {
        [Test]
        public void MapFrom_Should_map_a_Icustomer_to_a_customerDto()
        {
            ICustomer customer = new Customer("Foo", 2, 25);
            ICustomerDTOMapper mapper = new CustomerDTOMapper();
            CustomerDTO dto = mapper.MapFrom(customer);

            Assert.That(dto.Age, Is.EqualTo(customer.Age));
            Assert.That(dto.Id, Is.EqualTo(customer.Id));
            Assert.That(dto.Name, Is.EqualTo(customer.Name));
        }
    }
}