using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using FooTheory.CodeCamp.DI.CustomContainer;
using FooTheory.CodeCamp.DI.DataAccess;
using FooTheory.CodeCamp.DI.Interfaces.DataAccess;
using FooTheory.CodeCamp.DI.Interfaces.DTO;
using FooTheory.CodeCamp.DI.Interfaces.Services;
using FooTheory.CodeCamp.DI.Interfaces.Services.Mappers;
using FooTheory.CodeCamp.DI.Services;
using FooTheory.CodeCamp.DI.Services.Mappers;

namespace FooTheory.CodeCamp.DI.WebApp
{
    public partial class CustomContainerExample : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            // 
            // Set up the container (this could be done elsewhere, but for example
            // I've put it here)
            // 
            using (CustomDependencyContainer container = new CustomDependencyContainer())
            {
                container.RegisterImplmentationOf<ICustomerDTOMapper>(new CustomerDTOMapper());
                container.RegisterImplmentationOf<ICustomerRepository>(new RandomCustomerRepository());

                container.RegisterImplmentationOf<ICustomerService>
                    (
                    new CustomerService(
                        container.GetImplementationOf<ICustomerRepository>(),
                        container.GetImplementationOf<ICustomerDTOMapper>()
                        )
                    );

                // 
                // Get the service from the container
                // 
                ICustomerService service = container.GetImplementationOf<ICustomerService>();


                int customerID = 5;
                CustomerDTO dto = service.GetACustomerFrom(customerID);
                Response.Write(String.Format("Name: {0}", dto.Name)); // 
            }
        }
    }
}
