using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using FooTheory.CodeCamp.DI.DataAccess;
using FooTheory.CodeCamp.DI.Interfaces.DataAccess;
using FooTheory.CodeCamp.DI.Interfaces.DTO;
using FooTheory.CodeCamp.DI.Interfaces.Services.Mappers;
using FooTheory.CodeCamp.DI.Services;
using FooTheory.CodeCamp.DI.Services.Mappers;

namespace FooTheory.CodeCamp.DI.WebApp
{
    public partial class ShowCustomerName : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            int customerId = 5;
            //CustomerDTO dto = new CustomerService().GetACustomerFrom(customerId);
            //customerNameLiteral.Text = String.Format("Name: {0}", dto.Name);

            #region DI Implementation

            ICustomerRepository repository = new RandomCustomerRepository();
            ICustomerDTOMapper mapper = new CustomerDTOMapper();
            CustomerDTO dto =
                new CustomerService(repository, mapper).GetACustomerFrom(customerId);
            customerNameLiteral.Text = String.Format("Name: {0}", dto.Name);

            #endregion

            
        }
    }
}
