﻿using System;
using System.Collections.Generic;
using System.Text;

namespace FooTheory.CodeCamp.DI.CustomContainer
{
    public class CustomDependencyContainer : IDisposable
    {
        // Usually will be "interface (type), concrete implementation (object)" 
        private readonly IDictionary<Type, object> components;


        public CustomDependencyContainer()
        {
            components = new Dictionary<Type, object>();
        }


        public void RegisterImplmentationOf<T>(T component)
        {
            components.Add(typeof(T), component);
        }


        public T GetImplementationOf<T>()
        {
            return (T)components[typeof(T)];
        }


        public void Dispose()
        {
            components.Clear();
        }
    }
}
